#include <iostream>
using namespace std;

char rotateCh(char ch, int n)
{
	ch = ch + n;
	while (ch > 'Z')
		ch -= 26;
	return ch;
}

string rotate(string s)
{
	int val = 0;
	for(int i=0; i<s.length(); i++)
		val += (s[i] - 'A');
//cout << val << endl;
	val %= 26;
	string news = "";
	for(int i=0; i<s.length(); i++)
		news += rotateCh(s[i], val);
	return news;
}

string merge(string s1, string s2)
{
	string news = "";
	for(int i=0; i<s1.length(); i++)
		news += rotateCh(s1[i], s2[i]-'A');
	return news;
}

int main()
{
	string s;

	cin >> s;
	string left = s.substr(0,s.length()/2);
	string right  = s.substr(s.length()/2,s.length()/2);
//	cout << left << ' ' << right << endl;
	left = rotate(left);
	right = rotate(right);
//	cout << left << ' ' << right << endl;
	cout << merge(left, right) << endl;
}

